//////////////////////////////////////////////////////////////////////
//
//                                                signalTable_HMA.mq4 
//                                                Nicolaev Victor
//                                                vinin@mail.ru
//
//////////////////////////////////////////////////////////////////////
#property copyright "Nicolaev Victor"
#property link      "vinin@mail.ru"

#property indicator_chart_window

extern int       period=16;
extern int       method=3;                        
extern int       price=0;        


extern int scaleX=20,
           scaleY=20,
           offsetX=35,
           offsetY=20,
           fontSize=20,
           corner=2,
           symbolCodeBuy=228,  //228
           symbolCodeSell=230, 
           symbolCodeNoSignal=224; 
           
extern color signalBuyColor=LawnGreen,
             signalSellColor=Red,
             noSignalColor=Yellow,
             textColor=Gold;            
            
int    nTimeFrame[]={  1,   5,  15,   30,  60,  240,1440,10080,43200};  
string sTimeFrame[]={"M1","M5","M15","M30","H1","H4","D1", "W1","MN1"};
       //       

string   Work_value[][9];
color    Work_color[][9];
#include <WorkSymbol.mqh>

int init() {
   Work_init();
   ArrayResize(Work_value, Work_count);
   ArrayResize(Work_color, Work_count);
   ArrayInitialize(Work_value,0);

  return(0);
}
  
int start() {
   int i, j;
   for (i=0;i<Work_count;i++){
      for (j=0;j<9;j++) {

         double tmp0=0;
         tmp0+=iCustom(Work_symbol[i],nTimeFrame[j],"_HMA",period,method,price,0,0);
         tmp0-=iCustom(Work_symbol[i],nTimeFrame[j],"_HMA",period,method,price,0,1);

         double tmp1=0;
         tmp1+=iCustom(Work_symbol[i],nTimeFrame[j],"_HMA",period,method,price,0,1);
         tmp1-=iCustom(Work_symbol[i],nTimeFrame[j],"_HMA",period,method,price,0,2);

         Work_value[i,j]=CharToStr(symbolCodeNoSignal);
         Work_color[i,j]=noSignalColor;

         if (tmp0>0){
            Work_value[i,j]= CharToStr(symbolCodeBuy); 
            if (tmp1>0) Work_color[i,j]=signalBuyColor;
         }
         if (tmp0<0) { 
            Work_value[i,j]= CharToStr(symbolCodeSell);
            if (tmp1<0) Work_color[i,j]=signalSellColor;
         }
      }   
   }
   Redraw();
   return(0);
}

//////////////////////////////////////////////////////////////////////
//
//  deinit()                       
//
//////////////////////////////////////////////////////////////////////
int deinit() {
   int i, j;
   string sname;
  //  
   for(j=0;j<Work_count;j++) {
      sname="HMA_Symbol"+IntToStr(j);
      if (ObjectFind(sname) != -1) 
         ObjectDelete(sname);   
   }
      //  
   for(j=0;j<Work_count;j++) 
      for(i=0;i<9;i++) {
         sname="HMA_Signal"+IntToStr(i,j);
         if (ObjectFind(sname) != -1) 
            ObjectDelete(sname);   
      }
  
  //      
   for(i=0;i<9;i++) {
      sname="HMA_TimeFrame"+IntToStr(i);
      if (ObjectFind(sname) != -1) 
         ObjectDelete(sname);   
  }

   return(0);
}

void Redraw(){
  int i, j;
  string sname;
  //  
   for(j=0;j<Work_count;j++) {
      sname="HMA_Symbol"+IntToStr(j);
      if (ObjectFind(sname) == -1) ObjectCreate(sname,OBJ_LABEL,0,0,0,0,0);   
      ObjectSet(sname,OBJPROP_CORNER,corner);
      ObjectSet(sname,OBJPROP_XDISTANCE,offsetX-25);
      ObjectSet(sname,OBJPROP_YDISTANCE,j*(scaleY)+offsetY+8);
      ObjectSetText(sname,Work_symbol[j],8,"Tahoma",textColor);      

  }

   //  
   for(j=0;j<Work_count;j++) {
      for(i=0;i<9;i++) {
         sname="HMA_Signal"+IntToStr(i,j);
         if (ObjectFind(sname) == -1) {
            ObjectCreate(sname,OBJ_LABEL,0,0,0,0,0);
         }
         ObjectSet(sname,OBJPROP_CORNER,corner);
         ObjectSet(sname,OBJPROP_XDISTANCE,i*scaleX+offsetX+25);
         ObjectSet(sname,OBJPROP_YDISTANCE,j*scaleY+20);
         ObjectSetText(sname,Work_value[j,i],fontSize,"Wingdings",Work_color[j,i]);
      }
   }
  
  //      
   for(i=0;i<9;i++) {
      sname="HMA_TimeFrame"+IntToStr(i);
      if (ObjectFind(sname) == -1) {
         ObjectCreate(sname,OBJ_LABEL,0,0,0,0,0);   
      }
      ObjectSet(sname,OBJPROP_CORNER,corner);
      ObjectSet(sname,OBJPROP_XDISTANCE,i*scaleX+offsetX+25);
      ObjectSet(sname,OBJPROP_YDISTANCE,offsetY-10);
      ObjectSetText(sname,sTimeFrame[i],8,"Tahoma",textColor);
   }
  

}

string IntToStr(int i, int j=-1){
   string s1="",s2="";
   s1="00"+i;
   int n=StringLen(s1);
   s1=StringSubstr(s1,n-2);
   if (j>=0) {
      s2="00"+j;
      n=StringLen(s2);
      s2=StringSubstr(s2,n-2);
   }
   return(StringConcatenate(s1,s2));
}